////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s              OVM Tutorial            s////
////s                                      s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////


class env extends ovm_env;

    `ovm_component_utils(env)
     agent ag1;
     agent ag2;
      
    function new(string name, ovm_component parent);
        super.new(name, parent);
    endfunction

    function void build();
        ovm_report_info(get_full_name(),"Build", OVM_LOG);
        ag1 = agent::type_id::create("ag1",this);   
        ag2 = agent::type_id::create("ag2",this);   
    endfunction

    function void connect();
        ovm_report_info(get_full_name(),"Connect", OVM_LOG);
    endfunction

    function void end_of_elaboration();
        ovm_report_info(get_full_name(),"End_of_elaboration", OVM_LOG);
    endfunction

    function void start_of_simulation();
        ovm_report_info(get_full_name(),"Start_of_simulation", OVM_LOG);
    endfunction

    task run();
        ovm_report_info(get_full_name(),"Run", OVM_LOG);
    endtask

    function void extract();
        ovm_report_info(get_full_name(),"Extract", OVM_LOG);
    endfunction

    function void check();
        ovm_report_info(get_full_name(),"Check", OVM_LOG);
    endfunction

    function void report();
        ovm_report_info(get_full_name(),"Report", OVM_LOG);
    endfunction

endclass


